package fr.soleil.docking.util;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import fr.soleil.docking.view.IView;

/**
 * A class that gives some common useful methods about docking
 * 
 * @author girardot
 */
public class DockingUtils {

    /**
     * Generates an {@link AbstractAction} that can be used to display a given {@link IView}
     * 
     * @param view The concerned {@link IView}
     * @return An {@link AbstractAction}
     */
    public static AbstractAction generateShowViewAction(final IView view) {
        AbstractAction action = new AbstractAction(view.getTitle()) {
            private static final long serialVersionUID = 7366344574285043141L;

            @Override
            public void actionPerformed(ActionEvent e) {
                view.setVisible(true);
            }
        };
        action.putValue(AbstractAction.SMALL_ICON, view.getIcon());
        return action;
    }

}
